#include "Xparticles_system.h"


/*------------------------------------------------------------------*/
XParticles_System::XParticles_System(LPDIRECT3DDEVICE9 pDevice , int n , int s):Particles_System(n,s)
{
	if( FAILED( pDevice->CreateVertexBuffer( n*sizeof(PARTICLE_VERTEX),
                                             D3DUSAGE_POINTS, 0 ,
                                             D3DPOOL_MANAGED, &g_pVB_Particles, NULL ) ) )
    {
		MessageBox(NULL, "Could not create vertex buffer", "Textures.exe", MB_OK);        
    }
	
}

HRESULT XParticles_System::fillVertexBuffer()
{
	// Fill the vertex buffer.
    PARTICLE_VERTEX* pVertices;
    if( FAILED( g_pVB_Particles->Lock( 0, 0, (VOID**)&pVertices, 0 ) ) )
	{
		MessageBox(NULL, "Could not lock", "Textures.exe", MB_OK);
        return E_FAIL;
	}	

	std::vector<Particle>::iterator itr;	
	int n=0;
	for( itr=particules.begin() ; itr != particules.end() ; itr++)
	{		
		pVertices[n].x = (*itr).x;
		pVertices[n].y = (*itr).y;
		pVertices[n].z = (*itr).z;
		pVertices[n].fade = (*itr).fade;

		n++;
	}	

    g_pVB_Particles->Unlock();

	return S_OK;
}
